<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>X11 Texture From Pixmap</title>
<meta name="generator" content="DocBook XSL Stylesheets V1.78.1">
<link rel="home" href="index.html" title="Cogl 2.0 Reference Manual">
<link rel="up" href="cogl-meta-textures.html" title="Meta Textures">
<link rel="prev" href="cogl-2.0-experimental-Sliced-Textures.html" title="Sliced Textures">
<link rel="next" href="cogl-primitive-textures.html" title="Primitive Textures">
<meta name="generator" content="GTK-Doc V1.18.1 (XML mode)">
<link rel="stylesheet" href="style.css" type="text/css">
</head>
<body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF">
<table class="navigation" id="top" width="100%" summary="Navigation header" cellpadding="2" cellspacing="2">
<tr valign="middle">
<td><a accesskey="p" href="cogl-2.0-experimental-Sliced-Textures.html"><img src="left.png" width="24" height="24" border="0" alt="Prev"></a></td>
<td><a accesskey="u" href="cogl-meta-textures.html"><img src="up.png" width="24" height="24" border="0" alt="Up"></a></td>
<td><a accesskey="h" href="index.html"><img src="home.png" width="24" height="24" border="0" alt="Home"></a></td>
<th width="100%" align="center">Cogl 2.0 Reference Manual</th>
<td><a accesskey="n" href="cogl-primitive-textures.html"><img src="right.png" width="24" height="24" border="0" alt="Next"></a></td>
</tr>
<tr><td colspan="5" class="shortcuts">
<a href="#cogl-2.0-experimental-X11-Texture-From-Pixmap.synopsis" class="shortcut">Top</a>
                   | 
                  <a href="#cogl-2.0-experimental-X11-Texture-From-Pixmap.description" class="shortcut">Description</a>
</td></tr>
</table>
<div class="refentry">
<a name="cogl-2.0-experimental-X11-Texture-From-Pixmap"></a><div class="titlepage"></div>
<div class="refnamediv"><table width="100%"><tr>
<td valign="top">
<h2><span class="refentrytitle"><a name="cogl-2.0-experimental-X11-Texture-From-Pixmap.top_of_page"></a>X11 Texture From Pixmap</span></h2>
<p>X11 Texture From Pixmap — Functions for creating and manipulating 2D meta
                    textures derived from X11 pixmaps.</p>
</td>
<td valign="top" align="right"></td>
</tr></table></div>
<div class="refsynopsisdiv">
<a name="cogl-2.0-experimental-X11-Texture-From-Pixmap.synopsis"></a><h2>Synopsis</h2>
<pre class="synopsis">                    <a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#CoglTexturePixmapX11" title="CoglTexturePixmapX11">CoglTexturePixmapX11</a>;
<a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            <a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#cogl-is-texture-pixmap-x11" title="cogl_is_texture_pixmap_x11 ()">cogl_is_texture_pixmap_x11</a>          (<em class="parameter"><code><span class="type">void</span> *object</code></em>);

<a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#CoglTexturePixmapX11" title="CoglTexturePixmapX11"><span class="returnvalue">CoglTexturePixmapX11</span></a> * <a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#cogl-texture-pixmap-x11-new" title="cogl_texture_pixmap_x11_new ()">cogl_texture_pixmap_x11_new</a>      (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#CoglContext" title="CoglContext"><span class="type">CoglContext</span></a> *context</code></em>,
                                                         <em class="parameter"><code><span class="type">uint32_t</span> pixmap</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="type">CoglBool</span></a> automatic_updates</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Exception-handling.html#CoglError" title="CoglError"><span class="type">CoglError</span></a> **error</code></em>);

<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#cogl-texture-pixmap-x11-update-area" title="cogl_texture_pixmap_x11_update_area ()">cogl_texture_pixmap_x11_update_area</a> (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#CoglTexturePixmapX11" title="CoglTexturePixmapX11"><span class="type">CoglTexturePixmapX11</span></a> *texture</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> x</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> y</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> width</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> height</code></em>);
<a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            <a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#cogl-texture-pixmap-x11-is-using-tfp-extension" title="cogl_texture_pixmap_x11_is_using_tfp_extension ()">cogl_texture_pixmap_x11_is_using_tfp_extension</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#CoglTexturePixmapX11" title="CoglTexturePixmapX11"><span class="type">CoglTexturePixmapX11</span></a> *texture</code></em>);
enum                <a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#CoglTexturePixmapX11ReportLevel" title="enum CoglTexturePixmapX11ReportLevel">CoglTexturePixmapX11ReportLevel</a>;
<span class="returnvalue">void</span>                <a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#cogl-texture-pixmap-x11-set-damage-object" title="cogl_texture_pixmap_x11_set_damage_object ()">cogl_texture_pixmap_x11_set_damage_object</a>
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#CoglTexturePixmapX11" title="CoglTexturePixmapX11"><span class="type">CoglTexturePixmapX11</span></a> *texture</code></em>,
                                                         <em class="parameter"><code><span class="type">uint32_t</span> damage</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#CoglTexturePixmapX11ReportLevel" title="enum CoglTexturePixmapX11ReportLevel"><span class="type">CoglTexturePixmapX11ReportLevel</span></a> report_level</code></em>);
</pre>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-X11-Texture-From-Pixmap.description"></a><h2>Description</h2>
<p>
These functions allow high-level meta textures (See the
<a class="link" href="cogl-2.0-experimental-High-Level-Meta-Textures.html#CoglMetaTexture" title="CoglMetaTexture"><span class="type">CoglMetaTexture</span></a> interface) that derive their contents from an X11
pixmap.
</p>
</div>
<div class="refsect1">
<a name="cogl-2.0-experimental-X11-Texture-From-Pixmap.details"></a><h2>Details</h2>
<div class="refsect2">
<a name="CoglTexturePixmapX11"></a><h3>CoglTexturePixmapX11</h3>
<pre class="programlisting">typedef struct _CoglTexturePixmapX11 CoglTexturePixmapX11;</pre>
</div>
<hr>
<div class="refsect2">
<a name="cogl-is-texture-pixmap-x11"></a><h3>cogl_is_texture_pixmap_x11 ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            cogl_is_texture_pixmap_x11          (<em class="parameter"><code><span class="type">void</span> *object</code></em>);</pre>
<p>
Checks whether <em class="parameter"><code>object</code></em> points to a <a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#CoglTexturePixmapX11" title="CoglTexturePixmapX11"><span class="type">CoglTexturePixmapX11</span></a> instance.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>object</code></em> :</span></p></td>
<td>A pointer to a <a class="link" href="cogl-2.0-experimental-The-Object-Interface.html#CoglObject" title="CoglObject"><span class="type">CoglObject</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> if the object is a <a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#CoglTexturePixmapX11" title="CoglTexturePixmapX11"><span class="type">CoglTexturePixmapX11</span></a>, and
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a> otherwise</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.4</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-texture-pixmap-x11-new"></a><h3>cogl_texture_pixmap_x11_new ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#CoglTexturePixmapX11" title="CoglTexturePixmapX11"><span class="returnvalue">CoglTexturePixmapX11</span></a> * cogl_texture_pixmap_x11_new      (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#CoglContext" title="CoglContext"><span class="type">CoglContext</span></a> *context</code></em>,
                                                         <em class="parameter"><code><span class="type">uint32_t</span> pixmap</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="type">CoglBool</span></a> automatic_updates</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-Exception-handling.html#CoglError" title="CoglError"><span class="type">CoglError</span></a> **error</code></em>);</pre>
<p>
Creates a texture that contains the contents of <em class="parameter"><code>pixmap</code></em>. If
<em class="parameter"><code>automatic_updates</code></em> is <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> then Cogl will attempt to listen for
damage events on the pixmap and automatically update the texture
when it changes.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>context</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-The-Top-Level-Context.html#CoglContext" title="CoglContext"><span class="type">CoglContext</span></a>
</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>pixmap</code></em> :</span></p></td>
<td>A X11 pixmap ID</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>automatic_updates</code></em> :</span></p></td>
<td>Whether to automatically copy the contents of
the pixmap to the texture.</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>error</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-Exception-handling.html#CoglError" title="CoglError"><span class="type">CoglError</span></a> for exceptions</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>a new <a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#CoglTexturePixmapX11" title="CoglTexturePixmapX11"><span class="type">CoglTexturePixmapX11</span></a> instance</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.10</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-texture-pixmap-x11-update-area"></a><h3>cogl_texture_pixmap_x11_update_area ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_texture_pixmap_x11_update_area (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#CoglTexturePixmapX11" title="CoglTexturePixmapX11"><span class="type">CoglTexturePixmapX11</span></a> *texture</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> x</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> y</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> width</code></em>,
                                                         <em class="parameter"><code><span class="type">int</span> height</code></em>);</pre>
<p>
Forces an update of the given <em class="parameter"><code>texture</code></em> so that it is refreshed with
the contents of the pixmap that was given to
<a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#cogl-texture-pixmap-x11-new" title="cogl_texture_pixmap_x11_new ()"><code class="function">cogl_texture_pixmap_x11_new()</code></a>.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>texture</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#CoglTexturePixmapX11" title="CoglTexturePixmapX11"><span class="type">CoglTexturePixmapX11</span></a> instance</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>x</code></em> :</span></p></td>
<td>x coordinate of the area to update</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>y</code></em> :</span></p></td>
<td>y coordinate of the area to update</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>width</code></em> :</span></p></td>
<td>width of the area to update</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>height</code></em> :</span></p></td>
<td>height of the area to update</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.4</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="cogl-texture-pixmap-x11-is-using-tfp-extension"></a><h3>cogl_texture_pixmap_x11_is_using_tfp_extension ()</h3>
<pre class="programlisting"><a class="link" href="cogl-2.0-experimental-Common-Types.html#CoglBool" title="CoglBool"><span class="returnvalue">CoglBool</span></a>            cogl_texture_pixmap_x11_is_using_tfp_extension
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#CoglTexturePixmapX11" title="CoglTexturePixmapX11"><span class="type">CoglTexturePixmapX11</span></a> *texture</code></em>);</pre>
<p>
Checks whether the given <em class="parameter"><code>texture</code></em> is using the
GLX_EXT_texture_from_pixmap or similar extension to copy the
contents of the pixmap to the texture.  This extension is usually
implemented as zero-copy operation so it implies the updates are
working efficiently.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>texture</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#CoglTexturePixmapX11" title="CoglTexturePixmapX11"><span class="type">CoglTexturePixmapX11</span></a> instance</td>
</tr>
<tr>
<td><p><span class="term"><span class="emphasis"><em>Returns</em></span> :</span></p></td>
<td>
<a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a> if the texture is using an efficient extension
and <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#FALSE:CAPS"><code class="literal">FALSE</code></a> otherwise</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.4</p>
<p class="stability">Stability Level: Unstable</p>
</div>
<hr>
<div class="refsect2">
<a name="CoglTexturePixmapX11ReportLevel"></a><h3>enum CoglTexturePixmapX11ReportLevel</h3>
<pre class="programlisting">typedef enum {
  COGL_TEXTURE_PIXMAP_X11_DAMAGE_RAW_RECTANGLES,
  COGL_TEXTURE_PIXMAP_X11_DAMAGE_DELTA_RECTANGLES,
  COGL_TEXTURE_PIXMAP_X11_DAMAGE_BOUNDING_BOX,
  COGL_TEXTURE_PIXMAP_X11_DAMAGE_NON_EMPTY
} CoglTexturePixmapX11ReportLevel;
</pre>
</div>
<hr>
<div class="refsect2">
<a name="cogl-texture-pixmap-x11-set-damage-object"></a><h3>cogl_texture_pixmap_x11_set_damage_object ()</h3>
<pre class="programlisting"><span class="returnvalue">void</span>                cogl_texture_pixmap_x11_set_damage_object
                                                        (<em class="parameter"><code><a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#CoglTexturePixmapX11" title="CoglTexturePixmapX11"><span class="type">CoglTexturePixmapX11</span></a> *texture</code></em>,
                                                         <em class="parameter"><code><span class="type">uint32_t</span> damage</code></em>,
                                                         <em class="parameter"><code><a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#CoglTexturePixmapX11ReportLevel" title="enum CoglTexturePixmapX11ReportLevel"><span class="type">CoglTexturePixmapX11ReportLevel</span></a> report_level</code></em>);</pre>
<p>
Sets the damage object that will be used to track automatic updates
to the <em class="parameter"><code>texture</code></em>. Damage tracking can be disabled by passing 0 for
<em class="parameter"><code>damage</code></em>. Otherwise this damage will replace the one used if <a href="http://library.gnome.org/devel/glib/unstable/glib-Standard-Macros.html#TRUE:CAPS"><code class="literal">TRUE</code></a>
was passed for automatic_updates to <a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#cogl-texture-pixmap-x11-new" title="cogl_texture_pixmap_x11_new ()"><code class="function">cogl_texture_pixmap_x11_new()</code></a>.
</p>
<p>
Note that Cogl will subtract from the damage region as it processes
damage events.
</p>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term"><em class="parameter"><code>texture</code></em> :</span></p></td>
<td>A <a class="link" href="cogl-2.0-experimental-X11-Texture-From-Pixmap.html#CoglTexturePixmapX11" title="CoglTexturePixmapX11"><span class="type">CoglTexturePixmapX11</span></a> instance</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>damage</code></em> :</span></p></td>
<td>A X11 Damage object or 0</td>
</tr>
<tr>
<td><p><span class="term"><em class="parameter"><code>report_level</code></em> :</span></p></td>
<td>The report level which describes how to interpret
the damage events. This should match the level that the damage
object was created with.</td>
</tr>
</tbody>
</table></div>
<p class="since">Since 1.4</p>
<p class="stability">Stability Level: Unstable</p>
</div>
</div>
</div>
<div class="footer">
<hr>
          Generated by GTK-Doc V1.18.1</div>
</body>
</html>